<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Sound Manager: LibSoundmanager Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Sound Manager
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_lib_soundmanager.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">LibSoundmanager Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="libsoundmanager_8hpp_source.html">libsoundmanager.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:abd76525512641c001c3187629b58db07"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#abd76525512641c001c3187629b58db07">EventType_SM</a> { <a class="el" href="class_lib_soundmanager.html#abd76525512641c001c3187629b58db07a3dabba8ce44eb980fd8f02a84ec7d002">Event_AsyncSetSourceState</a> = 1
 }</td></tr>
<tr class="separator:abd76525512641c001c3187629b58db07"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c28533bfc9315d8d0b417653611aba7"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a7c28533bfc9315d8d0b417653611aba7">handler_fun</a> = std::function&lt; void(struct json_object *)&gt;</td></tr>
<tr class="separator:a7c28533bfc9315d8d0b417653611aba7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a8b51e9891813cb62dd12109c017ad106"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a8b51e9891813cb62dd12109c017ad106">LibSoundmanager</a> ()</td></tr>
<tr class="separator:a8b51e9891813cb62dd12109c017ad106"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abf861908e3d6d85d2b3c08683b08f934"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#abf861908e3d6d85d2b3c08683b08f934">~LibSoundmanager</a> ()</td></tr>
<tr class="separator:abf861908e3d6d85d2b3c08683b08f934"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a148fae0b5ed7be3b562939c417b1f95d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a148fae0b5ed7be3b562939c417b1f95d">LibSoundmanager</a> (const <a class="el" href="class_lib_soundmanager.html">LibSoundmanager</a> &amp;)=delete</td></tr>
<tr class="separator:a148fae0b5ed7be3b562939c417b1f95d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a875e992495c9448bc778dfe70325f672"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_lib_soundmanager.html">LibSoundmanager</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a875e992495c9448bc778dfe70325f672">operator=</a> (const <a class="el" href="class_lib_soundmanager.html">LibSoundmanager</a> &amp;)=delete</td></tr>
<tr class="separator:a875e992495c9448bc778dfe70325f672"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad5026736048e49c640b25f790409a65e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#ad5026736048e49c640b25f790409a65e">init</a> (int port, const std::string &amp;token)</td></tr>
<tr class="separator:ad5026736048e49c640b25f790409a65e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5353df3686a64c74c9672efd0c156351"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a5353df3686a64c74c9672efd0c156351">registerSource</a> (const std::string &amp;sourceName)</td></tr>
<tr class="separator:a5353df3686a64c74c9672efd0c156351"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa570a8373e057127c85107e13053669c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#aa570a8373e057127c85107e13053669c">connect</a> (int sourceID, int sinkID)</td></tr>
<tr class="separator:aa570a8373e057127c85107e13053669c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ed96ee8a96cf0fdc79335e631e314c4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a2ed96ee8a96cf0fdc79335e631e314c4">connect</a> (int sourceID, const std::string &amp;sinkName)</td></tr>
<tr class="separator:a2ed96ee8a96cf0fdc79335e631e314c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e59dfb464c81824d32f3391dea9b295"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a3e59dfb464c81824d32f3391dea9b295">disconnect</a> (int connectionID)</td></tr>
<tr class="separator:a3e59dfb464c81824d32f3391dea9b295"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a66e6fd5ef9955df2295c450400d6eb74"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a66e6fd5ef9955df2295c450400d6eb74">ackSetSourceState</a> (int handle, int error)</td></tr>
<tr class="separator:a66e6fd5ef9955df2295c450400d6eb74"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fe952a4dabbab6126cc23e36c79c773"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a1fe952a4dabbab6126cc23e36c79c773">call</a> (const std::string &amp;verb, struct json_object *arg)</td></tr>
<tr class="separator:a1fe952a4dabbab6126cc23e36c79c773"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a872d65bc665189c7b6a882c6067daaed"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a872d65bc665189c7b6a882c6067daaed">call</a> (const char *verb, struct json_object *arg)</td></tr>
<tr class="separator:a872d65bc665189c7b6a882c6067daaed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9cd7c5470cb135f9b1aa56d790c7e91e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a9cd7c5470cb135f9b1aa56d790c7e91e">subscribe</a> (const std::string &amp;event_name)</td></tr>
<tr class="separator:a9cd7c5470cb135f9b1aa56d790c7e91e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a21060844aa7efad6473b6104546afb06"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a21060844aa7efad6473b6104546afb06">unsubscribe</a> (const std::string &amp;event_name)</td></tr>
<tr class="separator:a21060844aa7efad6473b6104546afb06"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af39e2ddfb07ec049565b61ab4e1fbf8d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#af39e2ddfb07ec049565b61ab4e1fbf8d">set_event_handler</a> (enum <a class="el" href="class_lib_soundmanager.html#abd76525512641c001c3187629b58db07">EventType_SM</a> et, <a class="el" href="class_lib_soundmanager.html#a7c28533bfc9315d8d0b417653611aba7">handler_fun</a> f)</td></tr>
<tr class="separator:af39e2ddfb07ec049565b61ab4e1fbf8d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a472149619f68c2387d4ff7e02845db26"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a472149619f68c2387d4ff7e02845db26">register_callback</a> (void(*event_cb)(const std::string &amp;<a class="el" href="structevent.html">event</a>, struct json_object *event_contents), void(*reply_cb)(struct json_object *reply_contents), void(*hangup_cb)(void)=nullptr)</td></tr>
<tr class="separator:a472149619f68c2387d4ff7e02845db26"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7fd9ce3fae6ab6e0806ff099ad681f0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#ab7fd9ce3fae6ab6e0806ff099ad681f0">register_callback</a> (void(*reply_cb)(struct json_object *reply_contents), void(*hangup_cb)(void)=nullptr)</td></tr>
<tr class="separator:ab7fd9ce3fae6ab6e0806ff099ad681f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a71a8165cb15c7815aa95a8955f5cd7f6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a71a8165cb15c7815aa95a8955f5cd7f6">on_hangup</a> (void *closure, struct afb_wsj1 *wsj)</td></tr>
<tr class="separator:a71a8165cb15c7815aa95a8955f5cd7f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ba2255cb1d29c77c4c6a2267949eda0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a3ba2255cb1d29c77c4c6a2267949eda0">on_call</a> (void *closure, const char *api, const char *verb, struct afb_wsj1_msg *msg)</td></tr>
<tr class="separator:a3ba2255cb1d29c77c4c6a2267949eda0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86ef62e7847cd20e9cafbc1f6c017b3e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a86ef62e7847cd20e9cafbc1f6c017b3e">on_event</a> (void *closure, const char *<a class="el" href="structevent.html">event</a>, struct afb_wsj1_msg *msg)</td></tr>
<tr class="separator:a86ef62e7847cd20e9cafbc1f6c017b3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a69b4f10e509605a570cc52c795bc9d51"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_lib_soundmanager.html#a69b4f10e509605a570cc52c795bc9d51">on_reply</a> (void *closure, struct afb_wsj1_msg *msg)</td></tr>
<tr class="separator:a69b4f10e509605a570cc52c795bc9d51"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock">
<p class="definition">Definition at line <a class="el" href="libsoundmanager_8hpp_source.html#l00032">32</a> of file <a class="el" href="libsoundmanager_8hpp_source.html">libsoundmanager.hpp</a>.</p>
</div><h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a7c28533bfc9315d8d0b417653611aba7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7c28533bfc9315d8d0b417653611aba7">&#9670;&nbsp;</a></span>handler_fun</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="class_lib_soundmanager.html#a7c28533bfc9315d8d0b417653611aba7">LibSoundmanager::handler_fun</a> =  std::function&lt;void(struct json_object*)&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8hpp_source.html#l00041">41</a> of file <a class="el" href="libsoundmanager_8hpp_source.html">libsoundmanager.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="abd76525512641c001c3187629b58db07"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abd76525512641c001c3187629b58db07">&#9670;&nbsp;</a></span>EventType_SM</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="class_lib_soundmanager.html#abd76525512641c001c3187629b58db07">LibSoundmanager::EventType_SM</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="abd76525512641c001c3187629b58db07a3dabba8ce44eb980fd8f02a84ec7d002"></a>Event_AsyncSetSourceState&#160;</td><td class="fielddoc"></td></tr>
</table>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8hpp_source.html#l00043">43</a> of file <a class="el" href="libsoundmanager_8hpp_source.html">libsoundmanager.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a8b51e9891813cb62dd12109c017ad106"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8b51e9891813cb62dd12109c017ad106">&#9670;&nbsp;</a></span>LibSoundmanager() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LibSoundmanager::LibSoundmanager </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00096">96</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="abf861908e3d6d85d2b3c08683b08f934"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abf861908e3d6d85d2b3c08683b08f934">&#9670;&nbsp;</a></span>~LibSoundmanager()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LibSoundmanager::~LibSoundmanager </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00100">100</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a148fae0b5ed7be3b562939c417b1f95d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a148fae0b5ed7be3b562939c417b1f95d">&#9670;&nbsp;</a></span>LibSoundmanager() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">LibSoundmanager::LibSoundmanager </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_lib_soundmanager.html">LibSoundmanager</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a66e6fd5ef9955df2295c450400d6eb74"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a66e6fd5ef9955df2295c450400d6eb74">&#9670;&nbsp;</a></span>ackSetSourceState()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::ackSetSourceState </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>error</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function calls the ackSetSourceState of Audio Manager via WebSocket</p>
<h4>Parameters</h4>
<ul>
<li>sourceID [in] : This parameter is returned value of ackSetSourceState</li>
<li>handle [in] : This parameter is returned value of ackSetSourceState</li>
<li>errno [in] : If you have some errors, input ohter than 0. 0 means acknowledge</li>
</ul>
<h4>Return</h4>
<ul>
<li>Returns 0 on success or -1 in case of transmission error.</li>
</ul>
<h4>Note</h4>
<p>This function must be called when application get asyncSetSourceState event Input handle number attached in asyncSetSourceState and error number(0 is acknowledge) </p>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00374">374</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a1fe952a4dabbab6126cc23e36c79c773"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1fe952a4dabbab6126cc23e36c79c773">&#9670;&nbsp;</a></span>call() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::call </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>verb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct json_object *&#160;</td>
          <td class="paramname"><em>arg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a872d65bc665189c7b6a882c6067daaed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a872d65bc665189c7b6a882c6067daaed">&#9670;&nbsp;</a></span>call() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::call </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>verb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct json_object *&#160;</td>
          <td class="paramname"><em>arg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function calls the API of Audio Manager via WebSocket This function is overload function of "call"</p>
<h4>Parameters</h4>
<ul>
<li>verb [in] : This argument should be specified to the API name (e.g. "connect")</li>
<li>arg [in] : This argument should be specified to the argument of API. And this argument expects JSON object</li>
</ul>
<h4>Return</h4>
<ul>
<li>Returns 0 on success or -1 in case of transmission error.</li>
</ul>
<h4>Note</h4>
<p>To call Audio Manager's APIs, the application should set its function name, arguments to JSON format. </p>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00436">436</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="aa570a8373e057127c85107e13053669c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa570a8373e057127c85107e13053669c">&#9670;&nbsp;</a></span>connect() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::connect </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>sourceID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>sinkID</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function calls connect of Audio Manager via WebSocket connect is to get sound right</p>
<h4>Parameters</h4>
<ul>
<li>sourceID [in] : This argument should be specified to the sourceID as int. This parameter is returned value of registerSource</li>
<li>sinkID [in] : This argument should be specified to the sinkID as int. ID is specified by AudioManager</li>
</ul>
<h4>Return</h4>
<ul>
<li>Returns 0 on success or -1 in case of transmission error.</li>
</ul>
<h4>Note</h4>
<p>This function must be called to get source right connectionID is </p>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00287">287</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a2ed96ee8a96cf0fdc79335e631e314c4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2ed96ee8a96cf0fdc79335e631e314c4">&#9670;&nbsp;</a></span>connect() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::connect </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>sourceID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>sinkName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a3e59dfb464c81824d32f3391dea9b295"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3e59dfb464c81824d32f3391dea9b295">&#9670;&nbsp;</a></span>disconnect()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::disconnect </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>connectionID</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function calls the disconnect of Audio Manager via WebSocket</p>
<h4>Parameters</h4>
<ul>
<li>connectionID [in] : This parameter is returned value of connect</li>
</ul>
<h4>Return</h4>
<ul>
<li>Returns 0 on success or -1 in case of transmission error.</li>
</ul>
<h4>Note</h4>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00347">347</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="ad5026736048e49c640b25f790409a65e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5026736048e49c640b25f790409a65e">&#9670;&nbsp;</a></span>init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::init </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>token</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function is initialization function</p>
<h4>Parameters</h4>
<ul>
<li>port [in] : This argument should be specified to the port number to be used for websocket</li>
<li>token [in] : This argument should be specified to the token to be used for websocket</li>
</ul>
<h4>Return</h4>
<p>Returns 0 on success or -1 in case of transmission error.</p>
<h4>Note</h4>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00126">126</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a3ba2255cb1d29c77c4c6a2267949eda0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ba2255cb1d29c77c4c6a2267949eda0">&#9670;&nbsp;</a></span>on_call()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LibSoundmanager::on_call </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>closure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>api</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>verb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct afb_wsj1_msg *&#160;</td>
          <td class="paramname"><em>msg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00547">547</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a86ef62e7847cd20e9cafbc1f6c017b3e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a86ef62e7847cd20e9cafbc1f6c017b3e">&#9670;&nbsp;</a></span>on_event()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LibSoundmanager::on_event </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>closure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>event</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct afb_wsj1_msg *&#160;</td>
          <td class="paramname"><em>msg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00558">558</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a71a8165cb15c7815aa95a8955f5cd7f6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a71a8165cb15c7815aa95a8955f5cd7f6">&#9670;&nbsp;</a></span>on_hangup()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LibSoundmanager::on_hangup </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>closure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct afb_wsj1 *&#160;</td>
          <td class="paramname"><em>wsj</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00538">538</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a69b4f10e509605a570cc52c795bc9d51"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a69b4f10e509605a570cc52c795bc9d51">&#9670;&nbsp;</a></span>on_reply()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LibSoundmanager::on_reply </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>closure</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct afb_wsj1_msg *&#160;</td>
          <td class="paramname"><em>msg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00578">578</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a875e992495c9448bc778dfe70325f672"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a875e992495c9448bc778dfe70325f672">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_lib_soundmanager.html">LibSoundmanager</a>&amp; LibSoundmanager::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_lib_soundmanager.html">LibSoundmanager</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a472149619f68c2387d4ff7e02845db26"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a472149619f68c2387d4ff7e02845db26">&#9670;&nbsp;</a></span>register_callback() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LibSoundmanager::register_callback </td>
          <td>(</td>
          <td class="paramtype">void(*)(const std::string &amp;<a class="el" href="structevent.html">event</a>, struct json_object *event_contents)&#160;</td>
          <td class="paramname"><em>event_cb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(struct json_object *reply_contents)&#160;</td>
          <td class="paramname"><em>reply_cb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(void)&#160;</td>
          <td class="paramname"><em>hangup_cb</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ab7fd9ce3fae6ab6e0806ff099ad681f0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab7fd9ce3fae6ab6e0806ff099ad681f0">&#9670;&nbsp;</a></span>register_callback() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LibSoundmanager::register_callback </td>
          <td>(</td>
          <td class="paramtype">void(*)(struct json_object *reply_contents)&#160;</td>
          <td class="paramname"><em>reply_cb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(void)&#160;</td>
          <td class="paramname"><em>hangup_cb</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function is overload of register_callback. This registers callback function for reply/event message from sound manager</p>
<h4>Parameters</h4>
<ul>
<li>reply_cb [in] : This argument should be specified to the reply callback for call function</li>
<li>hangup_cb [in] : This argument should be specified to the hangup callback for call function. nullptr is defaulty set.</li>
</ul>
<h4>Return</h4>
<h4>Note</h4>
<p>Event callback is invoked by sound manager for event you subscribed. This function for convinience for user uses set_event_handler If you would like to get event, please call subscribe function before/after this function </p>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00236">236</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a5353df3686a64c74c9672efd0c156351"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5353df3686a64c74c9672efd0c156351">&#9670;&nbsp;</a></span>registerSource()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::registerSource </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>sourceName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function calls registerSource of Audio Manager via WebSocket registerSource is registration as source for policy management</p>
<h4>Parameters</h4>
<ul>
<li>sourceName [in] : This argument should be specified to the source name (e.g. "MediaPlayer")</li>
</ul>
<h4>Return</h4>
<ul>
<li>Returns 0 on success or -1 in case of transmission error.</li>
</ul>
<h4>Note</h4>
<p>This function must be called to get source ID mainConnectionID is returned by async reply function </p>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00259">259</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="af39e2ddfb07ec049565b61ab4e1fbf8d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af39e2ddfb07ec049565b61ab4e1fbf8d">&#9670;&nbsp;</a></span>set_event_handler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LibSoundmanager::set_event_handler </td>
          <td>(</td>
          <td class="paramtype">enum <a class="el" href="class_lib_soundmanager.html#abd76525512641c001c3187629b58db07">EventType_SM</a>&#160;</td>
          <td class="paramname"><em>et</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_lib_soundmanager.html#a7c28533bfc9315d8d0b417653611aba7">handler_fun</a>&#160;</td>
          <td class="paramname"><em>f</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function calls the ackSetSourceState of Audio Manager via WebSocket</p>
<h4>Parameters</h4>
<ul>
<li>EventType_AsyncSetSourceState [in] : This parameter is EventType of soundmanager</li>
<li>handler_func [in] : This parameter is callback function</li>
</ul>
<h4>Return</h4>
<ul>
<li>Returns 0 on success or -1 in case of transmission error.</li>
</ul>
<h4>Note</h4>
<p>This function must be called when application get asyncSetSourceState event Input handle number attached in asyncSetSourceState and error number(0 is acknowledge) </p>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00528">528</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a9cd7c5470cb135f9b1aa56d790c7e91e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9cd7c5470cb135f9b1aa56d790c7e91e">&#9670;&nbsp;</a></span>subscribe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::subscribe </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>event_name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Register callback function for each event</p>
<h4>Parameters</h4>
<ul>
<li>event_name [in] : This argument should be specified to the event name</li>
</ul>
<h4>Return</h4>
<ul>
<li>Returns 0 on success or -1 in case of transmission error.</li>
</ul>
<h4>Note</h4>
<p>This function enables to get an event to your callback function. Regarding the list of event name, please refer to CommandSender API and RountingSender API. </p>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00469">469</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<a id="a21060844aa7efad6473b6104546afb06"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a21060844aa7efad6473b6104546afb06">&#9670;&nbsp;</a></span>unsubscribe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int LibSoundmanager::unsubscribe </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>event_name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Unregister callback function for each event</p>
<h4>Parameters</h4>
<ul>
<li>event_name [in] : This argument should be specified to the event name</li>
</ul>
<h4>Return</h4>
<ul>
<li>Returns 0 on success or -1 in case of transmission error.</li>
</ul>
<h4>Note</h4>
<p>This function disables to get an event to your callback function. </p>

<p class="definition">Definition at line <a class="el" href="libsoundmanager_8cpp_source.html#l00498">498</a> of file <a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>R:/SoundManagerBinding/include/<a class="el" href="libsoundmanager_8hpp_source.html">libsoundmanager.hpp</a></li>
<li>R:/SoundManagerBinding/libsoundmanager/<a class="el" href="libsoundmanager_8cpp_source.html">libsoundmanager.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_lib_soundmanager.html">LibSoundmanager</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
